
-- Before you can create a server-level audit specification you must create 
-- and configure a SQL Server Audit object that can be used for the server audit.

-- create a server level audit and define the target
-- target is Windows Application event log
CREATE SERVER AUDIT Test_SQL_Server_Audit
    TO APPLICATION_LOG
    /* The Queue Delay is set to 1000, meaning one second 
         intervals to write to the target. */
    WITH ( QUEUE_DELAY = 1000,  ON_FAILURE = CONTINUE);
GO

-- Create the server audit specification and map it to the Audit object.
CREATE SERVER AUDIT SPECIFICATION Test_Server_Audit_Specification
FOR SERVER AUDIT Test_SQL_Server_Audit
    ADD (FAILED_LOGIN_GROUP);
GO
    
-- Enable the audit 
ALTER SERVER AUDIT Test_SQL_Server_Audit
WITH (STATE = ON);
GO

ALTER SERVER AUDIT SPECIFICATION Test_Server_Audit_Specification
WITH (STATE = ON);
GO

-- Disable the audit 
ALTER SERVER AUDIT Test_SQL_Server_Audit
WITH (STATE = OFF);
GO

ALTER SERVER AUDIT SPECIFICATION Test_Server_Audit_Specification
WITH (STATE = OFF);
GO

DROP SERVER AUDIT SPECIFICATION Test_Server_Audit_Specification
GO

DROP SERVER AUDIT Test_SQL_Server_Audit
GO