------------------------------
-- Enable EKM
------------------------------
sp_configure 'show advanced options', 1
go

RECONFIGURE
go

sp_configure 'EKM provider enabled', 1
go

RECONFIGURE
go

-- Setup
CREATE CRYPTOGRAPHIC PROVIDER ekm_prov FROM FILE = 'c:\temp\EKM_TDEProv.dll'
go

-- user name and password to connect to the EKM module	
CREATE CREDENTIAL ekm_sacred WITH IDENTITY = 'user1', secret = 'gql_user1_pwd' FOR CRYPTOGRAPHIC PROVIDER ekm_prov;
go

-- add credential to login	
ALTER LOGIN [ZMV10\Administrator] ADD CREDENTIAL ekm_sacred;
go

CREATE DATABASE ekmdb;
go

-- Create the asym key
CREATE ASYMMETRIC KEY ekm_asky
	FROM PROVIDER [ekm_prov]
	WITH ALGORITHM = RSA_512,
	PROVIDER_KEY_NAME = 'key10_user1';
go

-- create DEK
USE ekmdb;
go

-- create login + credential
CREATE LOGIN ekm_alog
	FROM ASYMMETRIC KEY ekm_asky;

CREATE CREDENTIAL ekm_cred
	WITH IDENTITY = 'user1', secret = 'gql_user1_pwd' FOR CRYPTOGRAPHIC PROVIDER ekm_prov;

ALTER LOGIN ekm_alog
	ADD CREDENTIAL ekm_cred;

-- create DEK
CREATE DATABASE ENCRYPTION KEY
	WITH ALGORITHM = AES_256
	ENCRYPTION BY SERVER ASYMMETRIC KEY ekm_asky;

SELECT * FROM sys.dm_database_encryption_keys;
go

-- turn on encryption
ALTER DATABASE ekmdb SET ENCRYPTION ON;
go

SELECT * from sys.dm_database_encryption_keys;
go

-- cleanup
USE master;
go

ALTER LOGIN ekm_alog DROP CREDENTIAL ekm_cred;
ALTER LOGIN [ZMV10\Administrator] DROP CREDENTIAL ekm_sacred;
go

DROP CREDENTIAL ekm_cred;
DROP CREDENTIAL ekm_sacred;
go

DROP LOGIN ekm_alog;
go

DROP CRYPTOGRAPHIC PROVIDER ekm_prov;
go

DROP DATABASE ekmdb;
go

sp_configure 'EKM provider enabled', 0
go
RECONFIGURE
go
sp_configure 'show advanced options', 0
go
RECONFIGURE
go

