
/*
SQL 2008 after encryption is switched on for 
database, existing data is encrypted only in data files. Transaction logs 
remain unencrypted. Only new data is completely encrypted with TDE.
*/
-----------------------------------------------------------------------------------
USE master
go
IF(not EXISTS(SELECT * FROM sys.symmetric_keys WHERE name = 
'##MS_DatabaseMasterKey##'))
   CREATE MASTER KEY ENCRYPTION BY PASSWORD = '123$$$$$$$$$'

CREATE CERTIFICATE TDE_TestDB_DEKCert WITH SUBJECT = 'DEK Encryption Certificate'
go
CREATE DATABASE TDE_TestDB
go
USE TDE_TestDB
go
CREATE DATABASE ENCRYPTION KEY WITH ALGORITHM = AES_256
ENCRYPTION BY SERVER CERTIFICATE TDE_TestDB_DEKCert
go
CREATE TABLE dbo.Test1 (Data varchar(100) not null)

---------------------------------------------
INSERT dbo.Test1 VALUES('Secret1') -- database isn't encrypted yet
--------------------------------------------

ALTER DATABASE TDE_TestDB SET ENCRYPTION ON --Enable encryption

WHILE(not EXISTS(SELECT * FROM sys.dm_database_encryption_keys WHERE 
database_id = DB_ID() and encryption_state = 3))
   WAITFOR DELAY '00:00:01'

SELECT DB_NAME(database_id), * FROM sys.dm_database_encryption_keys

--------------------------------------------
INSERT dbo.Test1 VALUES('Secret2') -- databases is encrypted
--------------------------------------------
go
------------------------------------------------------------------------------------
/*
After SQL server shutdown, we cannot find string "Secret2" nor in data 
file (TDE_TestDB.mdf) nor in transaction log (TDE_TestDB_log.LDF). 
However, we can easily find string "Secret1" in transaction log 
(TDE_TestDB_log.LDF).
*/

use master
go

DROP DATABASE TDE_TestDB
DROP CERTIFICATE TDE_TestDB_DEKCert