/*============================================================================
  File:     dates_and_plans.sql

  Summary:  This script shows that, in SQL Server 2008 you can make a query 
			clause that would not be available as a search argument 
			(non-SARGable) into a SARGable query by casting to the new
			SQL Server date data type. 
			
			Run with the actual query plan on.

  Date:     August 2008

  SQL Server Version: 10.0.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Bob Beauchemin, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended only as a supplement to SQL Server Jumpstart program. 
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

use northwind
go

select * from orders
go

sp_helpindex 'orders'
go

--Turn on execution plans

-- index seek
select orderid, customerid, orderdate from orders 
  where orderdate >= '1997-03-24' and OrderDate < '1997-03-25';

-- index scan  
select orderid, customerid, orderdate from orders 
  where convert(varchar(10), orderdate, 20) = '1997-03-24';
  
-- index seek, cheaper plan than first one  
select orderid, customerid, orderdate from orders 
  where convert(date, orderdate) = '1997-03-24';