
use tempdb
go

-- on SQL Server 2005
CREATE PARTITION FUNCTION pf2005(datetime) AS RANGE RIGHT FOR VALUES ('2008-10-01', '2008-11-01', '2008-12-01');
CREATE PARTITION SCHEME ps2005 AS PARTITION pf2005 ALL TO ([PRIMARY]);

CREATE TABLE ptnsales(saledate DATETIME, salesperson INT, amount MONEY) ON ps2005(saledate);
INSERT INTO ptnsales (saledate, salesperson, amount) VALUES ('2008-10-20', 1, 250.00);
INSERT INTO ptnsales (saledate, salesperson, amount) VALUES ('2008-11-05', 2, 129.00);
INSERT INTO ptnsales (saledate, salesperson, amount) VALUES ('2008-12-23', 2, 98.00);
INSERT INTO ptnsales (saledate, salesperson, amount) VALUES ('2008-10-3', 1, 450.00);


SELECT * FROM ptnsales

-- this is not a parallel scan, though
SELECT * FROM ptnsales WHERE (saledate) NOT BETWEEN '2008-11-01' AND '2008-11-30';
go

-- this will generate a parallel scan
CREATE PARTITION FUNCTION pfparallel(INT) AS RANGE RIGHT FOR VALUES (100, 200, 300);
CREATE PARTITION SCHEME psparallel AS PARTITION pfparallel ALL TO ([PRIMARY]);
go
CREATE TABLE testscan(randomnum INT, value INT, data BINARY(3000)) ON psparallel(randomnum);
go

SET NOCOUNT ON;
DECLARE @i INT
SET @i = 0;
BEGIN TRANSACTION;
WHILE @i < 100000
BEGIN
INSERT INTO testscan(randomnum, value) VALUES (rand()*400, @i);
SET @i = @i + 1;
END;
COMMIT TRANSACTION;
go

-- now let's demonstrate a parallel scan over a partitioned table in SQL Server 2005
SELECT COUNT(*) FROM testscan;

-- join colocation
-- SQL Server 2008 join collocation still uses the constant scan + apply model
SELECT * FROM testscan t1 INNER JOIN testscan t2 ON t1.randomnum=t2.randomnum;


CREATE PARTITION FUNCTION pfinsert(INT) AS RANGE RIGHT FOR VALUES (100, 200, 300);
CREATE PARTITION SCHEME psinsert AS PARTITION pfinsert ALL TO ([PRIMARY]);
go
CREATE TABLE testinsert(ptncol INT, col2 INT) ON psinsert(ptncol);
go
-- look at defined values and predicate list of insert iterator
INSERT INTO testinsert(ptncol, col2) VALUES (1,2);
