
-- SQL login
create login fred with 
 password = 'StrongPW1' must_change,
 default_database = pubs,
 default_language = british,
 check_expiration = on,
 check_policy = on
go

-- Windows login based on user
create login [ZMV32\Mary] from windows
go

-- Windows login based on group
create login [ZMV32\payroll] from windows
go

create credential asbob with identity = 'ZMV32\bobb',
 secret = 'mypassword'
go

drop credential asbob
drop login [zmv32\payroll]
drop login [zmv32\Mary]
drop login fred
go

create login [ZMV32\payroll] from windows
go

use pubs
go

create user simon from login fred
-- sp_grantdbaccess will go away in future version
-- sp_grantdbaccess 'zmv32\Mary', 'Mary'
create user Mary from login [zmv32\Mary]
create user [zmv32\payroll] from login [zmv32\payroll]

create role payroll 
sp_addrolemember 'payroll', 'zmv32\payroll'

-- cleanup
sp_droprolemember 'payroll', 'zmv32\payroll'
drop role payroll
drop user simon
drop user Mary
drop schema [zmv32\payroll]
drop user [zmv32\payroll]
go

drop login [zmv32\payroll]
drop login [zmv32\Mary]
drop login fred
drop credential asbob
go