﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EDMSimpleTrace
{
    class Program
    {
        static void Main(string[] args)
        {
            pubsEntities model = new pubsEntities();
            InsertUpdateDelete(model);
            Queries(model);
        }

        static void InsertUpdateDelete(pubsEntities model)
        {
            try
            {
                // Code to add a new author
                authors a = new authors();
                a.au_id = "999-99-9999";
                a.au_lname = "McCoy";
                a.au_fname = "Mary";
                a.phone = "503-555-1212";
                a.address = "111 Any St";
                a.city = "Portland";
                a.state = "OR";
                a.zip = "97225";
                a.contract = true;

                model.AddToauthors(a);
                model.SaveChanges();

                a.state = "ME";
                model.SaveChanges();

                model.DeleteObject(a);
                model.SaveChanges();

            }
            catch (Exception e)
            {
               Console.WriteLine(e.Message);
               if (e.InnerException != null)
                   Console.WriteLine(e.InnerException.Message);
            }
        }

        static void Queries(pubsEntities model)
        {
            // simple projection
            var query1 = from a in model.authors
                         select new { a.au_id, a.au_fname, a.au_lname };

            foreach (var au in query1)
                Console.WriteLine("{0} {1} {2}", au.au_id, au.au_fname, au.au_lname);
        }
    }
}
