use tempdb
go

drop table bigtable
go

CREATE TABLE bigtable (
 id int identity primary key,
 col1 char(8000)
)
go

-- add 100 rows
declare @x int = 0;
while @x < 1000
  begin 
    insert bigtable values ('vf nifninivnidnvidnmcdomdcd');
    set @x += 1;
  end
GO

BEGIN TRAN 
  SELECT top 1 * FROM bigtable
COMMIT
GO
CHECKPOINT
GO

-- do decision support query
use AdventureWorksDW2008
go
select ProductAlternateKey, CalendarYear, SUM(SalesAmount)
from FactInternetSales fact
join DimDate
  on fact.OrderDateKey = DateKey
join DimProduct
  on DimProduct.ProductKey = fact.ProductKey
where CalendarYear BETWEEN 2003 AND 2004
  and ProductAlternateKey LIKE 'BK%'
group by ProductAlternateKey, CalendarYear
go
